/* XPLog -- an PPP-Dialer and Phonecost Program
 * Copyright (C) 1998 Stefan Kraus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */ 

#include "xplog.h"

/* HomeDirectory */
extern char *user;
extern char xpuser[1024];

extern const char *strdef;
extern char APuffer[256],BPuffer[256],CPuffer[256];

/* Filehandle */
extern FILE *fh; 

void Viewlog(void)
{
  /* create logfile path */
  strcpy(APuffer,xpuser);
  strcat(APuffer,"/.xplog.log");
  Viewer(1,0,APuffer);

  return;
}

void Viewcost(void)
{
  /* create logfile path */
  strcpy(APuffer,xpuser);
  strcat(APuffer,"/.xplog.calculation");
  Viewer(0,200,APuffer);

  return;
}

void Viewstat(void)
{
  /* create logfile path */
  strcpy(APuffer,xpuser);
  strcat(APuffer,"/.xplog.stat");
  Viewer(0,-360,APuffer);

  return;
}

/* Help Window */
void Viewhelp(void)
{
  /* create logfile path */
  strcpy(APuffer,XPHELP);
  Viewer(0,60,APuffer);

  return;
}


/* Snap Window */
void Viewsnap(void)
{
  /* create logfile path */
  strcpy(APuffer,xpuser);
  strcat(APuffer,"/.xplog.snap");
  Viewer(1,-130,APuffer);

  return;
}

/* Viewer */
void Viewer(int mo,int ab,char *txt)
{
  struct xplViewLog xplVL;

  int a,b,c;

  xplVL.form = fl_bgn_form(FL_UP_BOX,550+ab,350); 

   fl_set_border_width(2);

   /* Browser 334 */
   if (mo == 0)
     {
       xplVL.viewfield = fl_add_browser(FL_NORMAL_BROWSER,8,8,534+ab,306,"");
     }
   if (mo == 1)
     {
       xplVL.viewfield = fl_add_browser(FL_HOLD_BROWSER,8,8,534+ab,306,"");
     }
   fl_set_browser_fontsize(xplVL.viewfield,FL_NORMAL_FONT);
   fl_set_browser_fontstyle(xplVL.viewfield,FL_FIXED_STYLE);

   /* create logfile path */
   a = fl_load_browser(xplVL.viewfield,txt);

   xplVL.QPLframe = fl_add_frame(FL_DOWN_FRAME,10,316,530+ab,24,"");
   xplVL.QPLexit = fl_add_button(FL_NORMAL_BUTTON,245+(ab/2),318,60,20,_xpl_exit);

   /* Begin / End Selector */
   b = fl_get_browser_maxline(xplVL.viewfield);
   c = fl_get_browser_screenlines(xplVL.viewfield);  
   if (b > c)
     {
       xplVL.QPLbegin = fl_add_button(FL_NORMAL_BUTTON,223+(ab/2),318,20,20,"@4>|");
       xplVL.QPLend = fl_add_button(FL_NORMAL_BUTTON,307+(ab/2),318,20,20,"@6>|");
     }

   /* Edit Mode */
   if (mo == 1) 
     {
       xplVL.QPLsave = fl_add_button(FL_NORMAL_BUTTON,60,318,60,20,_xpl_save);
       xplVL.QPLdelete = fl_add_button(FL_NORMAL_BUTTON,348+(ab/2),318,60,20,_xpl_delete);
       xplVL.QPLdown = fl_add_button(FL_TOUCH_BUTTON,431+(ab/2),318,20,20,"@2>");
       xplVL.QPLup = fl_add_button(FL_TOUCH_BUTTON,453+(ab/2),318,20,20,"@8>");
     }


  fl_end_form();
      
  fl_show_form(xplVL.form,FL_PLACE_CENTER,FL_TRANSIENT,_xpl_wintitle);
      
  a=0;

  xplVL.ready=0;
  while (xplVL.ready == 0)
    {
      xplVL.obj = fl_do_forms();

      /* Exit */
      if (xplVL.obj == xplVL.QPLexit)
        {
          xplVL.ready=1;      
        }

      /* Begin */
      if (xplVL.obj == xplVL.QPLbegin)
        {
          fl_set_browser_topline(xplVL.viewfield,1);
        }

      /* End */
      if (xplVL.obj == xplVL.QPLend)
        {
          fl_set_browser_topline(xplVL.viewfield,(b-c)+1);
        }

      /* Browser */
      if (xplVL.obj == xplVL.viewfield)
        {
          a = fl_get_browser(xplVL.viewfield);
        }

      /* Delete Entry */
      if (xplVL.obj == xplVL.QPLdelete)
        {
          if (a > 0)
            {
              fl_delete_browser_line(xplVL.viewfield,a);
              if (a <= fl_get_browser_maxline(xplVL.viewfield))
                {
                  fl_select_browser_line(xplVL.viewfield,a);
                }
            }
        }

      /* Move Down */
      if (xplVL.obj == xplVL.QPLdown)
        {
          if ( a > 0 )
            {
              if (a < fl_get_browser_maxline(xplVL.viewfield))
                {
                  strdef = fl_get_browser_line(xplVL.viewfield,a);
                  strcpy(BPuffer,strdef);
                  strdef = fl_get_browser_line(xplVL.viewfield,a+1);
                  strcpy(CPuffer,strdef);
                  fl_replace_browser_line(xplVL.viewfield,a,CPuffer);
                  fl_replace_browser_line(xplVL.viewfield,a+1,BPuffer);
                  fl_select_browser_line(xplVL.viewfield,a+1);
                  a++;
                }
            }
        }

      /* Move Up */
      if (xplVL.obj == xplVL.QPLup)
        {
          if (a > 1)
            {
              strdef = fl_get_browser_line(xplVL.viewfield,a);
              strcpy(BPuffer,strdef);
              strdef = fl_get_browser_line(xplVL.viewfield,a-1);
              strcpy(CPuffer,strdef);
              fl_replace_browser_line(xplVL.viewfield,a,CPuffer);
              fl_replace_browser_line(xplVL.viewfield,a-1,BPuffer);
              fl_select_browser_line(xplVL.viewfield,a-1);
              a--;
            }
        }

      /* Save */
      if (xplVL.obj == xplVL.QPLsave)
        {
          cout << "write datas in <" << txt << "> !!!\n"; 

          /* write into file */
          if ((fh=fopen(txt,"w"))!=NULL)
            {

              b = fl_get_browser_maxline(xplVL.viewfield);
              for (c=1 ; c<=b ; c++)
                {
                  strdef = fl_get_browser_line(xplVL.viewfield,c);
                  strcpy(BPuffer,strdef);
                  strcat(BPuffer,"\n");
                  a=fputs(BPuffer,fh);
                }
              fclose(fh);
              chmod(APuffer,S_IRUSR|S_IWUSR);
            }
        }

    }
      
  fl_hide_form(xplVL.form);

  return;
}
